# TECH_COST_MOD
#
# By jodg5000

from CvPythonExtensions import *
import CvUtil
import PyHelpers		
import Popup as PyPopup

# globals
gc = CyGlobalContext()
PyPlayer = PyHelpers.PyPlayer
PyInfo = PyHelpers.PyInfo

class TechCost :

    def __init__( self, cem ) :

        self.em = cem
        self.em.addEventHandler( "techAcquired", self.modifyTechCost )
        self.em.addEventHandler( "OnLoad", self.onLoadGame )

        self.DEBUG_TECH_COST = 0        # 1 for debug popups ... also interesting for watching the AI pick techs
        if( self.DEBUG_TECH_COST ) :
            self.em.addEventHandler( "techSelected", self.onTechSelected )

    def modifyTechCost( self, argsList ) :
        iTechType, iTeam, iPlayer, bAnnounce = argsList
        
        techID = PyInfo.TechnologyInfo(iTechType).getID()

        iEra = PyInfo.TechnologyInfo(iTechType).getiEra()

        if( (iEra != 6) and (iEra != 0) ) :                             # No discount on ancient or future techs
                OrigCost = gc.getTechInfo(techID).getOrigResCost()      # This function added to dll by mod

                numTeams = CyGame().countCivTeamsAlive()
                numTeamsWhoKnow = CyGame().countKnownTechNumTeams(techID)

                numTeamsWhoKnow = min( [numTeamsWhoKnow, numTeams] )    # Don't count dead teams tech knowledge
                fraction = .11          # directly, linearly scales discount
                power = 1.6             # adjFracKnown is raised to this power ... larger number -> smaller discount for a few civs knowing
                addToNumCivs = 2        # added to denominator in adjFracKnown calculation, added so that fraction stays small for low number of teams

                adjFracKnown = (numTeamsWhoKnow/(1.0*numTeams+addToNumCivs))    # 1.0 forces float math

                discountPercent = fraction*iEra*pow(adjFracKnown,power)

                gc.getTechInfo(techID).setModResCost( max( [int((1.0-discountPercent)*OrigCost), int(OrigCost/2)] ) )   # This function added to dll by mod

                if (self.DEBUG_TECH_COST):
                        # Debug messages ... very interesting if you want to see what AI researches ...
                        dbgStr = '%s was finished by the %s\nera %d, numKnow %d\nfuture discount: %f'%(PyInfo.TechnologyInfo(iTechType).getDescription(), PyPlayer(iPlayer).getCivilizationName(), PyInfo.TechnologyInfo(iTechType).getiEra(),numTeamsWhoKnow,discountPercent)
                        CyInterface().addImmediateMessage(dbgStr,"")

        else :
                if (self.DEBUG_TECH_COST):
                        # Debug messages ... very interesting if you want to see what AI researches ...
                        dbgStr = '%s was finished by the %s\nera %d'%(PyInfo.TechnologyInfo(iTechType).getDescription(), PyPlayer(iPlayer).getCivilizationName(), PyInfo.TechnologyInfo(iTechType).getiEra())
                        CyInterface().addImmediateMessage(dbgStr,"")

    def onTechSelected( self, argsList ) :
        iTechType, iPlayer = argsList

	if( self.DEBUG_TECH_COST ) :
		techID = PyInfo.TechnologyInfo(iTechType).getID()
		dbgStr = '%s was selected by the %s\nmod cost: %d, orig:%d'%(PyInfo.TechnologyInfo(iTechType).getDescription(), PyPlayer(iPlayer).getCivilizationName(), PyInfo.TechnologyInfo(iTechType).getResearchCost(),gc.getTechInfo(techID).getOrigResCost())
                CyInterface().addImmediateMessage(dbgStr,"")

    def onLoadGame(self,argsList):
                temp = self.DEBUG_TECH_COST
                self.DEBUG_TECH_COST = 0       # Don't show messages

                # Loop through all known techs, recomputing discount
                for i in range(0,gc.getNumTechInfos()) :
                    self.modifyTechCost( [i,0,0,0] )

                self.DEBUG_TECH_COST = temp
                        




                
